﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.Collections.Generic;

namespace Demo01
{
    public class RouteItem
    {
        private long threshold;
        public long Threshold { get { return threshold; } set { threshold = value; } }

        private string target;
        public string Target { get { return target; } set { target = value; } }

        public RouteItem (string target, long threshold)
	    {
            this.threshold = threshold;
            this.target = target;
	    }
    }
    public sealed partial class ControllingFlows 
        : SequentialWorkflowActivity
	{
        public int leftCount = 0;
        int rightCount = 0;

        private long maxVoltLevel;
        public long MaxVoltLevel { get {return maxVoltLevel;} set {maxVoltLevel = value; }}

        public List<RouteItem> routeTable;
        public List<RouteItem> RouteTable { get {return routeTable;} set {routeTable = value; }}

        private void RightCondition(object sender, ConditionalEventArgs args)
        {
            args.Result = (rightCount <= 10);
            rightCount++;
        }

		public ControllingFlows()
		{
			InitializeComponent();
		}

        private void codeActivity1_ExecuteCode(object sender, EventArgs e)
        {
            Console.WriteLine("Max Volt Level for this switch is " + MaxVoltLevel );
            foreach (RouteItem ri in RouteTable)
                Console.WriteLine(ri.Target + " - " + ri.Threshold );
            Console.ReadLine();
        }

        private void delayActivity1_InitializeTimeoutDuration(object sender, EventArgs e)
        {

        }

        private void codeActivity2_ExecuteCode(object sender, EventArgs e)
        {
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine("Branch 1");
        }

        private void codeActivity3_ExecuteCode(object sender, EventArgs e)
        {
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine("Branch 2");

        }

        private void codeActivity4_ExecuteCode(object sender, EventArgs e)
        {
            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine("Left While");
            leftCount++;
        }

        private void codeActivity5_ExecuteCode(object sender, EventArgs e)
        {
            Console.ForegroundColor = ConsoleColor.Blue;
            Console.WriteLine("Right While");
            rightCount++;
        }

        private void codeActivity6_ExecuteCode(object sender, EventArgs e)
        {
            Console.ForegroundColor = ConsoleColor.Cyan;
            Console.WriteLine("End of all! Press enter to continue");
            Console.ReadLine();
        }
	}

}
