﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Workflow.Activities;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;


namespace Demo01
{
    class Program
    {
        static void Main(string[] args)
        {
            using(WorkflowRuntime workflowRuntime = new WorkflowRuntime())
            {
                ExternalDataExchangeService service = new ExternalDataExchangeService();
                workflowRuntime.AddService(service);
                FurnaceControlTrigger myFurnaceContol = new FurnaceControlTrigger();
                service.AddService(myFurnaceContol);

                AutoResetEvent waitHandle = new AutoResetEvent(false);
                workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) {waitHandle.Set();};
                workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
                {
                    Console.WriteLine(e.Exception.Message);
                    waitHandle.Set();
                };

                WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(Demo01.Workflow1));
                instance.Start();

                Console.WriteLine("What about the furnace?");
                Console.ReadLine();
                myFurnaceContol.SetProfileSignal(instance.InstanceId, "200");

                waitHandle.WaitOne();

                Console.WriteLine("Terminated");
                Console.ReadLine();
                
            }
        }
    }
}
