﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace Demo01
{
	public sealed partial class Workflow1: SequentialWorkflowActivity
	{
		public Workflow1()
		{
			InitializeComponent();
		}

        private void handleExternalEventActivity1_Invoked(object sender, ExternalDataEventArgs e)
        {
            Console.WriteLine(e.InstanceId);
        }

        private void codeActivity1_ExecuteCode(object sender, EventArgs e)
        {
            Console.WriteLine(this.AlarmSignalData.Temperature);
        }

        private void codeActivity2_ExecuteCode(object sender, EventArgs e)
        {
            Console.WriteLine(this.ProfileReachedData.Temperature);
            Console.WriteLine(this.ProfileReachedSender.ToString() );
        }

        public static DependencyProperty AlarmSignalDataProperty = DependencyProperty.Register("AlarmSignalData", typeof(Demo01.HeatProfileArgs), typeof(Demo01.Workflow1));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Parameters")]
        public HeatProfileArgs AlarmSignalData
        {
            get
            {
                return ((Demo01.HeatProfileArgs)(base.GetValue(Demo01.Workflow1.AlarmSignalDataProperty)));
            }
            set
            {
                base.SetValue(Demo01.Workflow1.AlarmSignalDataProperty, value);
            }
        }

        private void codeActivity3_ExecuteCode(object sender, EventArgs e)
        {
            Console.WriteLine("Timeout Expired!");
        }

        private void handleExternalEventActivity2_Invoked(object sender, ExternalDataEventArgs e)
        {

        }

        public static DependencyProperty ProfileReachedDataProperty = DependencyProperty.Register("ProfileReachedData", typeof(Demo01.HeatProfileArgs), typeof(Demo01.Workflow1));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Parameters")]
        public HeatProfileArgs ProfileReachedData
        {
            get
            {
                return ((Demo01.HeatProfileArgs)(base.GetValue(Demo01.Workflow1.ProfileReachedDataProperty)));
            }
            set
            {
                base.SetValue(Demo01.Workflow1.ProfileReachedDataProperty, value);
            }
        }

        public static DependencyProperty ProfileReachedSenderProperty = DependencyProperty.Register("ProfileReachedSender", typeof(System.Object), typeof(Demo01.Workflow1));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Parameters")]
        public Object ProfileReachedSender
        {
            get
            {
                return ((object)(base.GetValue(Demo01.Workflow1.ProfileReachedSenderProperty)));
            }
            set
            {
                base.SetValue(Demo01.Workflow1.ProfileReachedSenderProperty, value);
            }
        }

        
	}

}
